"""
Raspberry Pi Shutdown script.
=============================
"""
import datetime
import os
import sys
import time

os.chdir(os.path.dirname(os.path.abspath(__file__)))

# rp_mode = False
try:
    import pigpio  # type: ignore
    # rp_mode = True
except ModuleNotFoundError:
    pass
    # rp_mode = False


def main():
    """main

    :sig: () -> None
    """
    if os.name != "posix":
        return

    gpionumber = 14
    shutdown_time = 3
    wait_time = 0.5

    args = sys.argv
    if len(args) > 1:
        shutdown_time = float(args[1])

    pi = pigpio.pi()
    pi.set_mode(gpionumber, pigpio.INPUT)

    while True:
        counter = 0

        while True:
            if pi.read(gpionumber) == 0:
                counter = counter + 1
                if counter >= (shutdown_time / wait_time):
                    ## Log.
                    with open("./shutdown.log", "a", encoding="UTF-8") as f:
                        f.write(f"{datetime.datetime.now()}\n")
                    os.system('sudo shutdown -h now')
                    #print("sudo shutdown -h now")
                    break
            time.sleep(wait_time)


if __name__ == '__main__':
    main()
